/*******************************************************************************
Copyright © 2023 Sebastian Roith

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

window.TASK = {
	"code": "class Punkt {\n    int x = 0;\n    int y = 0;\n    String toString() {\n        String angabe;\n        angabe = this.x + '|' + this.y;\n        angabe = '(' + angabe + ')';\n        return angabe;\n    }\n}\n\nclass BenannterPunkt extends Punkt {\n    String name = \"\";\n    BenannterPunkt(String name, int x, int y) {\n        this.x = x;\n        this.y = y;\n        this.name = name;\n    }\n    String toString() {\n        String s = this.name;\n        s = s + super.toString();\n        return s;\n    }\n}\n\nBenannterPunkt p;\np = new BenannterPunkt(\"P\", 2, 3);\nprintln(p.toString());",
	"classes": [
		{
			"className": "Punkt",
			"abstact": true,
			"atts": [
				{
					"key": "x",
					"type": "int",
					"value": 0
				},
				{
					"key": "y",
					"type": "int",
					"value": 0
				}
			]
		},
		{
			"className": "BenannterPunkt",
			"abstact": true,
			"isa": [
				"Punkt"
			],
			"atts": [
				{
					"key": "x",
					"type": "int",
					"value": 0
				},
				{
					"key": "y",
					"type": "int",
					"value": 0
				},
				{
					"key": "name",
					"type": "String",
					"value": ""
				}
			]
		}
	],
	"notSelectable": [
		8,
		9,
		10,
		17,
		22,
		23,
		24
	],
	"methodCalls": [
		3,
		13,
		18
	],
	"classDeclarations": [
		{
			"line": 0,
			"className": "Punkt"
		},
		{
			"line": 11,
			"className": "BenannterPunkt"
		}
	],
	"steps": [
		{
			"task": "Führe den Code aus, indem du immer die Auswirkungen der hervorgehobenen Zeile in der Speichertabelle einträgst und die nächste auszuführende Codezeile auswählst. Achte besonders auf überladene Methoden. Zuerst musst du also ein Objekt der angegebenen Klasse erzeugen.",
			"line": 26,
			"vars": [
				{
					"key": "p",
					"type": "BenannterPunkt",
					"ref": null
				}
			],
			"allowArrays": false,
			"enableOverload": false,
			"autoremoveGarbage": false,
			"enableTextOut": false
		},
		{
			"line": 11,
			"vars": [
				{
					"key": "p",
					"type": "BenannterPunkt",
					"ref": null
				}
			],
			"task": "Weil die Klasse <code>BenannterPunkt</code> auf der Klasse <code>Punkt</code> basiert, musst du zuerst ein Objekt der Klasse <code>Punkt</code> erzeugen. Das werden wir erst anschließend zu einem Objekt der Klasse <code>BenannterPunkt</code> erweitern."
		},
		{
			"line": 0,
			"vars": {
				"instances": [],
				"vars": [
					{
						"key": "p",
						"type": "BenannterPunkt",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": "BenannterPunkt",
						"line": 26,
						"vars": []
					}
				]
			},
			"task": "Arbeite nun, wie gewohnt, die Deklarationen ab."
		},
		{
			"line": 1,
			"vars": {
				"instances": [],
				"vars": [
					{
						"key": "p",
						"type": "BenannterPunkt",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": "BenannterPunkt",
						"line": 26,
						"vars": []
					},
					{
						"className": "Punkt",
						"line": 11,
						"vars": []
					}
				]
			}
		},
		{
			"line": 2,
			"vars": {
				"instances": [],
				"vars": [
					{
						"key": "p",
						"type": "BenannterPunkt",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": "BenannterPunkt",
						"line": 26,
						"vars": []
					},
					{
						"className": "Punkt",
						"line": 11,
						"vars": [
							{
								"key": "x",
								"type": "int",
								"value": 0
							}
						]
					}
				]
			},
			"task": "Arbeite noch die letzte Deklarationen ab. Anschließend ist das Objekt der Klasse <code>Punkt</code> erzeugt. Klicke daher auf 💾 und erweitere das Objekt, indem du die Deklarationen der Klasse <code>BenannterPunkt</code> ausführst."
		},
		{
			"line": 12,
			"vars": {
				"instances": [],
				"vars": [
					{
						"key": "p",
						"type": "BenannterPunkt",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": "BenannterPunkt",
						"line": 26,
						"vars": [
							{
								"key": "x",
								"type": "int",
								"value": 0
							},
							{
								"key": "y",
								"type": "int",
								"value": 0
							}
						]
					}
				]
			},
			"task": "Achtung nach dem Abarbeiten dieser Deklaration: Die Klasse <code>BenannterPunkt</code> hat einen Konstruktor, der ausgeführt werden muss, bevor das erzeugen des Objektes abgeschlossen ist!"
		},
		{
			"line": 13,
			"vars": {
				"instances": [],
				"vars": [
					{
						"key": "p",
						"type": "BenannterPunkt",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": "BenannterPunkt",
						"line": 26,
						"vars": [
							{
								"key": "x",
								"type": "int",
								"value": 0
							},
							{
								"key": "y",
								"type": "int",
								"value": 0
							},
							{
								"key": "name",
								"type": "String",
								"value": ""
							}
						]
					}
				]
			},
			"task": "In die Speichertabelle konnte das neue Objekt aber bereits eingetragen werden. Setze den Wert von <code>this</code> auf die richtige Adresse und beachte die Parameter."
		},
		{
			"line": 14,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "BenannterPunkt",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 0
							},
							{
								"key": "y",
								"type": "int",
								"value": 0
							},
							{
								"key": "name",
								"type": "String",
								"value": ""
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "p",
						"type": "BenannterPunkt",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 26,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "name",
								"type": "String",
								"value": "P"
							},
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							}
						]
					}
				]
			},
			"task": "Die Wertezuweisungen im Konstruktor laufen ab wie gewohnt."
		},
		{
			"line": 15,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "BenannterPunkt",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 0
							},
							{
								"key": "name",
								"type": "String",
								"value": ""
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "p",
						"type": "BenannterPunkt",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 26,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "name",
								"type": "String",
								"value": "P"
							},
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							}
						]
					}
				]
			}
		},
		{
			"line": 16,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "BenannterPunkt",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							},
							{
								"key": "name",
								"type": "String",
								"value": ""
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "p",
						"type": "BenannterPunkt",
						"ref": null
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 26,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "name",
								"type": "String",
								"value": "P"
							},
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							}
						]
					}
				]
			},
			"task": "Nach der letzten Wertezuweisung im Konstruktor: Schließe nicht nur den Methodenaufruf ab, sondern auch die Zuweisung <code>p = new BenannterPunkt(\"P\", 2, 3);</code>."
		},
		{
			"line": 27,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "BenannterPunkt",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							},
							{
								"key": "name",
								"type": "String",
								"value": "P"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "p",
						"type": "BenannterPunkt",
						"ref": 0
					}
				],
				"scopes": []
			},
			"enableTextOut": true,
			"task": "Da <code>p</code> ein Objekt der Klasse <code>BenannterPunkt</code> ist, ist eindeutig, welche Methode <code>toString()</code> hier aufgerufen wird."
		},
		{
			"line": 18,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "BenannterPunkt",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							},
							{
								"key": "name",
								"type": "String",
								"value": "P"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "p",
						"type": "BenannterPunkt",
						"ref": 0
					}
				],
				"scopes": []
			},
			"task": "Vergiss nicht, den richtigen Wert von <code>this</code> festzulegen."
		},
		{
			"line": 19,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "BenannterPunkt",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							},
							{
								"key": "name",
								"type": "String",
								"value": "P"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "p",
						"type": "BenannterPunkt",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 27,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					}
				]
			},
			"task": "Eine Deklaration mit Wertezuweisung und Punktnotation. Also nichts Neues, einfach ausführen…"
		},
		{
			"line": 20,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "BenannterPunkt",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							},
							{
								"key": "name",
								"type": "String",
								"value": "P"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "p",
						"type": "BenannterPunkt",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 27,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "s",
								"type": "String",
								"value": "P"
							}
						]
					}
				]
			},
			"task": "<code>super</code> unterscheidet sich von <code>this</code> dadurch, dass die entsprechende Methode <em>der Elternklasse</em> aufgerufen wird."
		},
		{
			"line": 3,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "BenannterPunkt",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							},
							{
								"key": "name",
								"type": "String",
								"value": "P"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "p",
						"type": "BenannterPunkt",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 27,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "s",
								"type": "String",
								"value": "P"
							}
						]
					}
				]
			},
			"task": "Das ist eine Methode, die du wie gewohnt abarbeiten kannst. Vergiss nicht, die passende Adresse als Wert von <code>this</code> auszuwählen."
		},
		{
			"line": 4,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "BenannterPunkt",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							},
							{
								"key": "name",
								"type": "String",
								"value": "P"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "p",
						"type": "BenannterPunkt",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 27,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "s",
								"type": "String",
								"value": "P"
							}
						]
					},
					{
						"className": null,
						"line": 20,
						"vars": [
							{
								"key": "this",
								"ref": 0
							}
						]
					}
				]
			},
			"task": "Arbeite Anweisung für Anweisung diese Methode ab."
		},
		{
			"line": 5,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "BenannterPunkt",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							},
							{
								"key": "name",
								"type": "String",
								"value": "P"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "p",
						"type": "BenannterPunkt",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 27,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "s",
								"type": "String",
								"value": "P"
							}
						]
					},
					{
						"className": null,
						"line": 20,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "angabe",
								"type": "String",
								"value": ""
							}
						]
					}
				]
			}
		},
		{
			"line": 6,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "BenannterPunkt",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							},
							{
								"key": "name",
								"type": "String",
								"value": "P"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "p",
						"type": "BenannterPunkt",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 27,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "s",
								"type": "String",
								"value": "P"
							}
						]
					},
					{
						"className": null,
						"line": 20,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "angabe",
								"type": "String",
								"value": "2|3"
							}
						]
					}
				]
			}
		},
		{
			"line": 7,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "BenannterPunkt",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							},
							{
								"key": "name",
								"type": "String",
								"value": "P"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "p",
						"type": "BenannterPunkt",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 27,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "s",
								"type": "String",
								"value": "P"
							}
						]
					},
					{
						"className": null,
						"line": 20,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "angabe",
								"type": "String",
								"value": "(2|3)"
							}
						]
					}
				]
			}
		},
		{
			"line": 21,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "BenannterPunkt",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							},
							{
								"key": "name",
								"type": "String",
								"value": "P"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "p",
						"type": "BenannterPunkt",
						"ref": 0
					}
				],
				"scopes": [
					{
						"className": null,
						"line": 27,
						"vars": [
							{
								"key": "this",
								"ref": 0
							},
							{
								"key": "s",
								"type": "String",
								"value": "P(2|3)"
							}
						]
					}
				]
			}
		},
		{
			"line": "end",
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "BenannterPunkt",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							},
							{
								"key": "name",
								"type": "String",
								"value": "P"
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "p",
						"type": "BenannterPunkt",
						"ref": 0
					}
				],
				"scopes": []
			},
			"cout": "P(2|3)\n",
			"task": "Fertig!"
		}
	]
};